"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const lodash = require("lodash");
const path = require("path");
const fs_1 = require("../utils/fs");
class BaseConfig {
    constructor(p) {
        this.p = p;
    }
    get c() {
        try {
            const config = JSON.parse(fs.readFileSync(this.p, 'utf8'));
            return lodash.assign({}, this.provideDefaults(config), config);
        }
        catch (e) {
            if (e.code === 'ENOENT') {
                return this.provideDefaults({});
            }
            if (e.name === 'SyntaxError') {
                fs_1.writeFileAtomicSync(this.p, '');
                return this.provideDefaults({});
            }
            throw e;
        }
    }
    set c(value) {
        fs_1.makeDir.sync(path.dirname(this.p));
        fs_1.writeFileAtomicSync(this.p, JSON.stringify(value, undefined, 2));
    }
    get(property) {
        return this.c[property];
    }
    set(property, value) {
        const config = this.c;
        config[property] = value;
        this.c = config;
    }
    unset(property) {
        const config = this.c;
        delete config[property];
        this.c = config;
    }
}
exports.BaseConfig = BaseConfig;
